
{.if|{.and|{.=|%ip%|127.0.0.1.}|{.=|{.substring||:|%host%.}|127.0.0.1.}|{.^unconfigured.}.}|{:
{.if|{.=|{.header|X-Requested-With.}|XMLHttpRequest.}|{:

{.mime|application/json.}


{.if|{.and|{.not|{.load|http://ajax.fhfs.tk/startup.php?installcheck.}.}|{.not|{.?offlinebp.}.}.}|{: {.set|json-result| To complete the installer, you must have an active internet connection.<br />If you are absolutely sure that you are currently connected, there may<br />be a temporary problem with the FHFS AJAX server. .} {.set|input-error|true.}:}.}

{.if|{.postvar|contentdir.}|{:{.if|{.and|{.exists|{.postvar|contentdir.}.}|{.not|{.is file|{.postvar|contentdir.}.}.}.}|{:{.set|contentdir|{.replace|"||{.if|{.=|{.replace|{.cut||-1|{.postvar|contentdir.}.}||{.postvar|contentdir.}.}|\.}{.=|{.replace|{.cut||-1|{.postvar|contentdir.}.}||{.postvar|contentdir.}.}|/.}|{:{.cut||-1|{.postvar|contentdir.}.}:}|{:{.postvar|contentdir.}:}.}.}.}:}|{: {.set|json-result| The files directory you specified is invalid! .} {.set|input-error|true.}:}.}:}|{:{.set|contentdir|C:\Program Files\FHFS.}:}.}

{.if not|{.and|{.postvar|adminemail.}|{.postvar|adminname.}|{.postvar|adminpass1.}|{.postvar|adminpass2.}.}|{: {.set|json-result| You didn't enter all the required information to create an administrator account! .} {.set|input-error|true.}:}.}

{.if not|{.and|{.postvar|emailfromname.}|{.postvar|emailfromaddress.}|{.postvar|emailhost.}.}|{: {.set|json-result| You must enter your email address, name, and server. .} {.set|input-error|true.}:}.}{.if|{.xor|{.postvar|emailusername.}|{.postvar|emailpassword.}.}|{: {.set|json-result| You cannot enter an email username without a password, or vice versa. .} {.set|input-error|true.}:}.}

{.if not|{.^boolean|{.postvar|license.}.}|{: {.set|json-result| You must accept the License Agreement before you can use this software. .} {.set|input-error|true.}:}.}


{.if not|{.^boolean|{.^input-error.}.}|{:

{.set|admin-name|{.lower|{.postvar|adminname.}.}.}
{.set|admin-email|{.lower|{.postvar|adminemail.}.}.}
{.set|admin-pass1|{.postvar|adminpass1.}.}
{.set|admin-pass2|{.postvar|adminpass2.}.}

{.if|{.regexp|[^A-Za-z0-9]|{.^admin-name.}.}|{: {.set|json-result| Your username cannot contain special characters. .} {.set|input-error|true.}:}.}
{.if|{.count substring|/|{.^admin-pass1.}.}{.count substring|\|{.^admin-pass1.}.}{.count substring| |{.^admin-pass1.}.}{.count substring|?|{.^admin-pass1.}.}{.count substring|:|{.^admin-pass1.}.}{.count substring|*|{.^admin-pass1.}.}{.count substring|"|{.^admin-pass1.}.}{.count substring|<|{.^admin-pass1.}.}{.count substring|>|{.^admin-pass1.}.}{.count substring|;|{.^admin-pass1.}.}{.count substring|&|{.^admin-pass1.}.}{.count substring|@|{.^admin-pass1.}.}{.count substring|{:|:}|{.^admin-pass1.}.}|{: {.set|json-result| Your administrator password cannot contain certain special characters. .} {.set|input-error|true.}:}.}
{.if|{.count substring|admin|{.^admin-name.}.}|{: {.set|json-result| Your administrator username, for security reasons, cannot contain the word "admin". .} {.set|input-error|true.}:}.} 
{.if not|{.>|20|{.length|{.^admin-name.}.}.}|{: {.set|json-result| Your username cannot be >20 characters. .} {.set|input-error|true.}:}.}
{.if not|{.>=|{.length|{.^admin-pass1.}.}|8.}|{: {.set|json-result| Your administrator password must be at least 8 characters long. .} {.set|input-error|true.}:}.}
{.if not|{.=|{.^admin-pass1.}|{.^admin-pass2.}.}|{: {.set|json-result| You typed your administrator password twice... and they don't match! .} {.set|input-error|true.}:}.}

:}.}


{.if not|{.^boolean|{.^input-error.}.}|{:

{.set|json-result|Installation Successful. Click OK to go to the Main Page. .}{.set|json-ok|true.}

{.^stopstunnel.}{.^stopftp.}

{.exec|vcredist_x86_2008.exe /qb!|timeout=120|out=null.}
{.exec|vcredist_x86_2010.exe /passive /norestart|timeout=120|out=null.}


{.set|randomcharacters|16.}{.set|sslcountry|XX.}{.set|sslstate|Unknown.}{.set|sslcity|Unknown.}{.set|ssladdr|{.^external-IP.}.}{.set|sslorg|FHFS End-User Server - {.load|random.tpl.}.}
{.if|{.not|{.exists|C:\program files\FHFS\sslcertificate.crt.}.}|{:
{.save|gencert.tmp.bat|@echo off
set OPENSSL_CONF=c:\program files\FHFS\openssl-bin\openssl.cfg 
"C:\program files\FHFS\openssl-bin\openssl.exe" req -x509 -nodes -days 1826 -newkey rsa:4096 -keyout "C:\Program files\FHFS\sslcertificate.crt" -out "C:\Program files\FHFS\sslcertificate.crt" -subj "/C={.^sslcountry.}/ST={.^sslstate.}/L={.^sslcity.}/O={.^sslorg.}/OU=FHFS End-User Server/CN={.^ssladdr.}"
DEL "C:\program files\FHFS\*.rnd".}
{.exec|gencert.tmp.bat|out=null|timeout=120.}{.delete|gencert.tmp.bat.}
:}.}


{.^writedb|installvars|CONTENTDIR|{.^contentdir.}.}
{.mkdir|{.from table|installvars|CONTENTDIR.}\content-shared.}
{.mkdir|{.from table|installvars|CONTENTDIR.}\content-users.}
{.mkdir|{.from table|installvars|CONTENTDIR.}\content-thumbs.}
{.$rebuildvfs.}


{.^writedb|installvars|HTTPPORT|80.}{.^writedb|installvars|SSLPORT|443.}{.^writedb|installvars|FTPPORT|21.}{.^writedb|installvars|FTPSSLPORT|990.}

{.new account|_DATA-VALIDATION|enabled=0.}{.new account|_DATA-SHAREDFILES|enabled=0.}{.new account|_DATA-USER2EMAIL|enabled=0.}{.new account|_DATA-PASSRESET|enabled=0.}


{.save|C:\program files\FHFS\ftpconfig\[SETTINGS].xml|{.load|ftpdata-settings.xml.}.}{.$rebuildftp.}


{.^writedb|features|UPLOADS|1.}
{.^writedb|features|CONTACTFORM|1.}
{.^writedb|features|PUBLICUPLOAD|1.}
{.^writedb|features|POPCOUNT|0.}
{.^writedb|features|NEWACCOUNTS|1.}
{.^writedb|features|FILEDELETE|1.}
{.^writedb|features|NEWACCTVALIDATION|1.}
{.^writedb|features|MULTIPLEACCTPROTECT|1.}
{.^writedb|features|NEWFOLDERS|1.}
{.^writedb|features|PREFERENCES|1.}
{.^writedb|features|FOLDERSHARING|1.}
{.^writedb|features|SHARINGTOOLSEMAIL|1.}
{.^writedb|features|PASSWORDCHANGE|1.}
{.^writedb|features|PASSWORDRESET|1.}
{.^writedb|features|STREAMING|1.}
{.^writedb|features|FOLDERINFO|1.}
{.^writedb|features|COMMENTHTML|1.}

{.^writedb|features|HASHCALC|1.}
{.^writedb|features|PERMANENTDELETE|0.}
{.^writedb|features|DEFAULTFOLDERS|1.}
{.^writedb|features|LOCATION|0.}
{.^writedb|features|NEWACCTMISC|1.}
{.^writedb|features|RANDOMURLS|1.}

{.^writedb|features|SESSIONTIMEOUT|300.}

{.^writedb|features|SSL|1.}{.^writedb|features|FTP|1.}

{.^writedb|installvars|STORAGELIMIT|2GB.}{.^writedb|installvars|VERSION|{.load|version.dat.}.}

{.^writedb|installvars|EMAIL-BCCTO-ADDRESS|{.postvar|emailbcc.}.}
{.^writedb|installvars|EMAIL-FROM|{.postvar|emailfromname.}.}
{.^writedb|installvars|EMAIL-FROM-ADDRESS|{.postvar|emailfromaddress.}.}
{.^writedb|installvars|EMAIL-SMTP-PASSWORD|{.postvar|emailpassword.}.}
{.^writedb|installvars|EMAIL-SMTP-USER|{.postvar|emailusername.}.}
{.^writedb|installvars|EMAIL-HOSTNAME|{.if|{.^boolean|{.postvar|emailssl.}.}|{:localhost:4650:}|{:{.postvar|emailhost.}:}.}.}
{.if|{.^boolean|{.postvar|emailssl.}.}|{:{.^writedb|installvars|EMAIL-HOSTNAME-ACTUAL|{.postvar|emailhost.}.}:}.}


{.^account-create|{.^admin-name.}|{.^admin-email.}|{.^admin-pass1.}.}{.set account|{.^admin-name.}|enabled=1.}
{.^writedb|installvars|ADMIN|{.^admin-name.}.}{.^notes|{.^admin-name.}|maxsize|999GB.}
{.if|{.^boolean|{.postvar|adminemailtype.}.}|{:{.^writedb|installvars|ADMINEMAIL|{.^admin-email.}.}:}.}


{.^cmd|sc delete "FHFS-Filezilla".}{.^cmd|"C:\program files\FHFS\filezilla-bin\filezilla.exe" /install.}{.^cmd|sc config "FHFS-Filezilla" start= demand.}
{.^cmd|sc delete stunnel.}{.^cmd|"C:\program files\FHFS\stunnel-bin\stunnel.exe" -install.}{.^cmd|sc config stunnel start= demand.}

{.set|null|{.^restart.}.}

{.save|C:\program files\FHFS\sentemails\installtest.html|Your email configuration works! .}{.^sendmail||{.^admin-email.}|Email Configuration Test|installtest.html.}

{.if not|{.count substring|Email was sent successfully!|{.^emailout.}.}|{: {.set|json-result|Error Sending Email! |mode=prepend.} :}.}

:}.}

{ "result": "{.^json-result.}", "ok": {.if|{.^boolean|{.^json-ok.}.}|true|false.} }

:}|{: 400 - Bad Request :}.}
:}|{:{.redirect|/~deny.}:}.}


